close all
clear all
clc

dir_txt = '../data/'

%lettura immagine
[X MAP] = imread([dir_txt 'ingegneria.jpg'],'jpg');

%verifica il formato dell'array
size(X)

%mostra l'immagine
figure(1)
subplot(3,3,1)
imshow(X,[])

% mostra la prima banda azzerando le altre (R)
R = X;
R(:,:,2) = zeros;
R(:,:,3) = zeros;

subplot(3,3,4)
imshow(R, [])
title('R')

% mostra la seconda banda azzerando le altre (G)
G = X;
G(:,:,1) = zeros;
G(:,:,3) = zeros;

subplot(3,3,5)
imshow(G, [])
title('G')

% mostra la seconda banda azzerando le altre (B)
B = X;
B(:,:,1) = zeros;
B(:,:,2) = zeros;

subplot(3,3,6)
imshow(B, [])
title('B')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
% Mostra immagine di luminanza
L_mapping = [0.299 0.587 0.114];
I_mapping = [0.5959 -0.2746 -0.3213];
Q_mapping = [0.2115 -0.5227 0.3112];

L = L_mapping(1)*double(X(:,:,1)) + L_mapping(2)*double(X(:,:,2)) + L_mapping(3)*double(X(:,:,3));
subplot(3,3,7)
imshow(L, [])
title('Luminanza')

I = I_mapping(1)*double(X(:,:,1)) + I_mapping(2)*double(X(:,:,2)) + I_mapping(3)*double(X(:,:,3));
Q = Q_mapping(1)*double(X(:,:,1)) + Q_mapping(2)*double(X(:,:,2)) + Q_mapping(3)*double(X(:,:,3));

% mostra immagine di saturazione
S = sqrt(Q.^2 + I.^2);
subplot(3,3,8)
imshow(S, [])
title('Saturazione')

% mostra immagine di tinta
T = atan2(Q,I);
subplot(3,3,9)
imshow(T, [])
title('Tinta')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
% Alteriamo i colori
test=2

if (test==1)
  % Dividiamo la componente rossa per 2
  X1 = X;
  X1(:,:,1) = double(X1(:,:,2)) ./ 2;

  figure(1)
  subplot(3,3,2)
  imshow(X1,[])
elseif (test==2)
  % Saturiamo la componente rossa
  X1 = X;
  X1(:,:,1) = 255 * ones;

  figure(1)
  subplot(3,3,2)
  imshow(X1,[])
elseif (test==3)
  % Saturiamo la componente blu
  X1 = X;
  X1(:,:,3) = 255 * ones;
  figure(1)
  subplot(3,3,2)
  imshow(X1,[])
elseif (test==4)
  % Saturiamo la componente verde
  X1 = X;
  X1(:,:,2) = 255 * ones;
  figure(1)
  subplot(3,3,2)
  imshow(X1,[])
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
% Alteriamo i colori
T = [0.299 0.587 0.114;
0.5959 -0.2746 -0.3213;
0.2115 -0.5227 0.3112];

T_inv = inv(T);

% Vario le componenti di luminanza e crominanza
LM = L;
IM = 1.5*I;
QM = 0.3*Q;

% Modifica della tinta attraverso una rotazione
% rigida del vettore di crominanza
% dteta = pi/5 % rotazione in radianti
%QM=-I*sin(dteta) + Q*cos(dteta);

XF(:,:,1) = T_inv(1,1)*LM + T_inv(1,2)*IM + T_inv(1,3)*QM;
XF(:,:,2) = T_inv(2,1)*LM + T_inv(2,2)*IM + T_inv(2,3)*QM;
XF(:,:,3) = T_inv(3,1)*LM + T_inv(3,2)*IM + T_inv(3,3)*QM;
XFI = uint8(XF);

figure(1)
subplot(3,3,3)
imshow(XFI,[])
%
