close all
clear all
clc

dir_txt = '../data/'

%lettura immagine
[X MAP] = imread([dir_txt 'moto.jpg'],'jpg');

X = rgb2gray(X);

%verifica il formato dell'array
size(X)

% portiamo i valori nel range [0,1]
XN = double(X) / 255;

%mostra l'immagine
figure(1)
subplot(3,2,1)
%imshow(XN, [0 1])
imshow(X)

% calcola l'istogramma sugli Nbin bins
Nbin = 50;
[H1 x] = hist(XN(:), Nbin);
subplot(3,2,2)
bar(x,H1)
xlim([0,1]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sottoespongo

% Sottoesponi l'immagine riducendo il valore di ogni pixel di una costante
c = 75; % Costante di sottoesposizione
X_under = X - c;

% portiamo i valori nel range [0,1]
XN_under = double(X_under) / 255;

%mostra l'immagine
figure(1)
subplot(3,2,3)
imshow(XN_under)

% calcola l'istogramma sugli Nbin bins
Nbin = 50;
[H1 x] = hist(XN_under(:), Nbin);
subplot(3,2,4)
bar(x,H1)
xlim([0,1]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Sovraespongo

% Sovraesponi l'immagine aumentando il valore di ogni pixel di una costante
c = 75; % Costante di sottoesposizione
X_under = X + c;

% portiamo i valori nel range [0,1]
XN_under = double(X_under) / 255;

%mostra l'immagine
figure(1)
subplot(3,2,5)
imshow(XN_under)

% calcola l'istogramma sugli Nbin bins
Nbin = 50;
[H1 x] = hist(XN_under(:), Nbin);
subplot(3,2,6)
bar(x,H1)
xlim([0,1]);

