close all
clear all
clc

dir_txt = '../data/'

%lettura immagine
[X MAP] = imread([dir_txt 'moto.jpg'],'jpg');
X_orig = rgb2gray(X);
X = X_orig;

X = double(X)/255;

%verifica il formato dell'array
[M N] = size(X)

%mostra l'immagine
figure(1)
subplot(2,2,1)
imshow(X,[])

F = fft2(X);
%mostra l'immagine
figure(1)
subplot(2,2,2)
imshow(abs(F),[])
title('FFT')

Fc = fftshift(F);
figure(1)
subplot(2,2,3)
imshow(abs(Fc),[])
title('fftshift')

S2 = log(1 + abs(Fc));
figure(1)
subplot(2,2,4)
imshow(S2,[])
title('rescale')

filter_type = 4 %1 passabasso Gaussiano, 2 passaalto Gaussiano, 3 arrestabanda Gaussiano
                %4 filtro di enfasi in alta frequenza Gaussiano

% Crea un filtro passa basso ideale nel dominio della frequenza
D0_LP = 40; % parametro di taglio per il filtro passabasso
D0_HP = 40; % parametro di taglio per il filtro passaalto

C0 = 20;    % parametro per definire la banda del filtro
W = 30;     % Larghezza della banda

a = 0.1;   % costante utilizzata per traslare la gaussiana nel filtro di enfasi
b = 0.5;   % costante utilizzata per traslare la gaussiana nel filtro di enfasi


%D0_LOW = 20;  % parametro per definire la banda del filtro
%D0_HIGH = 80; % parametro per definire la banda del filtro

u = 0:(M-1);
v = 0:(N-1);
idx = find(u > M/2);
u(idx) = u(idx) - M;
idy = find(v > N/2);
v(idy) = v(idy) - N;
[V, U] = meshgrid(v, u);
D = sqrt(U.^2 + V.^2);

if (filter_type == 1)
  H = exp( - (D .^2 ) ./ (2 .* D0_LP .^ 2) );
elseif (filter_type == 2)
  H = 1.0 - exp( - (D .^2 ) ./ (2 .* D0_HP .^ 2));
elseif (filter_type == 3)
  H = 1.0 - exp( -(((D .^2 ) - C0.^2) ./ (D .* W)) .^ 2);
elseif (filter_type == 4)
  H = a + b .* (1.0 - exp( - (D .^2 ) ./ (2 .* D0_HP .^ 2)));

end

%mostra l'immagine
figure(2)
subplot(2,2,1)
imshow(H,[])
title('filter')

subplot(2,2,2)
imshow(fftshift(H),[])
title('fftshift filter')

FY = H .* F;
Y = ifft2(FY);

subplot(2,2,3)
imshow(log(1 + abs(fftshift(FY))),[])
title('Rescale fftshift(FFT image * FFT filter)')

if ((filter_type==4))% || (filter_type==3))
  Yeq = histeq(abs(Y), 255);

  figure(3)
  subplot(1,2,1)
  imshow(X,[])
  subplot(1,2,2)
  imshow(Yeq,[])
else
  figure(3)
  subplot(1,2,1)
  imshow(X,[])
  subplot(1,2,2)
  imshow(abs(Y),[])
end





