% pkg load image

close all
clear all
clc

dir_txt = '../data/'

%lettura immagine
[X MAP] = imread([dir_txt 'moto.jpg'],'jpg');
X_orig = rgb2gray(X);
X = X_orig;

X = double(X)/255;

%verifica il formato dell'array
size(X)

%mostra l'immagine
figure(1)
subplot(1,2,1)
imshow(X,[])
title('originale');

disp(['Orig Dim; ' mat2str(size(X))])

interp_vct = {"bilinear" "nearest" "bicubic"};

type = 4
interp_type = 2

if (type == 1)
  s = 4
  T = [s 0 0; 0 s 0; 0 0 1];
  title_str = 'scaling'
elseif (type == 2)
  T = [1 0 0; .5 1 0; 0 0 1]
  title_str = 'shear'
elseif (type == 3)
  T = [1 .5 0; 0 1 0; 0 0 1]
  title_str = 'shear'
elseif (type == 4)
  theta = pi/4
  T = [cos(theta) -sin(theta) 0; sin(theta) cos(theta) 0; 0 0 1]
  title_str = 'rotation'
end

current_interp = interp_vct{interp_type}

tform = maketform('affine', T);
Y = imtransform(X, tform, current_interp);
subplot(1,2,2)
imshow(Y,[])
title(['Trasformata ' title_str ' - Interp:' current_interp]);

disp(['Orig Dim; ' mat2str(size(Y))])
