close all
clear all
clc

dir_txt = '../data/'

%lettura immagine
[X MAP] = imread([dir_txt 'moto.jpg'],'jpg');

X = rgb2gray(X);
XN = double(X) / 255;

%verifica il formato dell'array
size(X)

gamma = 0.5
xmin = 0
xmax = 1
ymin = 0
ymax = 1

figure(1)
tt = [0:0.01:1; 0:0.01:1];
yy = mygamma(tt, xmin, xmax, ymin, ymax, gamma);
plot(tt,yy(1,:))
xlabel('x')
ylabel('y')

%mostra l'immagine
figure(2)
subplot(3,2,1)
imshow(XN)

% calcola l'istogramma sugli Nbin bins
Nbin = 50;
[H1 x] = hist(XN(:), Nbin);
subplot(3,2,2)
bar(x,H1)
xlim([0,1]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Y = mygamma(XN, xmin, xmax, ymin, ymax, gamma);

%mostra l'immagine
figure(2)
subplot(3,2,3)
imshow(Y)
title('Custom function')


% calcola l'istogramma sugli Nbin bins
Nbin = 50;
[H2 x] = hist(Y(:), Nbin);
subplot(3,2,4)
bar(x,H2)
xlim([0,1]);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Utilizzo di imadjust
Y_1 = imadjust(XN, [xmin xmax], [ymin ymax],gamma);
%mostra l'immagine
figure(2)
subplot(3,2,5)
imshow(Y_1)
title('imadjust')

% calcola l'istogramma sugli Nbin bins
Nbin = 50;
[H3 x] = hist(Y_1(:), Nbin);
subplot(3,2,6)
bar(x,H3)
xlim([0,1]);

